import BaseEntity from "./base.entity";
import User from "./user.entity";
export interface ResizeConfig {
    rotate: number;
    scaleX: number;
    scaleY: number;
    x: number;
    y: number;
    width: number;
    height: number;
}
export default class Media extends BaseEntity {
    hiddenFields: string[];
    id: number;
    originalName: string;
    slug: string;
    private is_directory;
    get isDirectory(): boolean;
    set isDirectory(value: boolean);
    mimetype: string;
    size: number;
    fileName: string;
    path: string;
    parent: Media;
    _children: Media[];
    owner: User;
    width: number;
    height: number;
    get children(): Promise<Media[]>;
    remove(): Promise<this>;
    /**
     * Create a cropped image starting of the current.
     * The image will be placed in the same directory as the original.
     * @param config: The configuration object containing the crop parameters
     * @return a promise with the new @type Media
     */
    resizeToNewEntity(config: ResizeConfig): Promise<Media>;
    static persist(uploadMedia: Express.Multer.File, user: User, directory?: Media): Promise<Media>;
    static mkdir(name: string, user?: User, directory?: Media | null): Promise<Media>;
    static getFolder(path: string): Promise<Media | undefined>;
    static findBySlug(slug: string): Promise<Media | undefined>;
    static findBySlugOrId(key: string): Promise<Media | undefined>;
    static findOneWithParent(id: number): Promise<Media | undefined>;
}
