"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var role_entity_1 = require("./role.entity");
var user_entity_1 = require("./user.entity");
var userLib = require("../libs/users");
var fs = require("fs");
var logger_1 = require("../logger");
function setup(entitiesPaths) {
    return __awaiter(this, void 0, void 0, function () {
        var admin, staff, administrator, _a, _i, entitiesPaths_1, path, files, index, entity;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, role_entity_1.default.getRepository().findOne({
                        where: { name: role_entity_1.default.ADMIN }
                    })];
                case 1:
                    admin = _b.sent();
                    if (!!admin) return [3 /*break*/, 3];
                    return [4 /*yield*/, createAdmin()];
                case 2:
                    admin = _b.sent();
                    _b.label = 3;
                case 3: return [4 /*yield*/, role_entity_1.default.getRepository().findOne({
                        where: { name: role_entity_1.default.STAFF }
                    })];
                case 4:
                    staff = _b.sent();
                    if (!staff) {
                        createStaff();
                    }
                    return [4 /*yield*/, user_entity_1.default.getRepository().findOne({
                            where: { email: "admin@gmail.com" }
                        })];
                case 5:
                    administrator = _b.sent();
                    if (!!administrator) return [3 /*break*/, 8];
                    administrator = new user_entity_1.default();
                    administrator.email = "admin@gmail.com";
                    _a = administrator;
                    return [4 /*yield*/, userLib.hashPassword("password")];
                case 6:
                    _a.password = _b.sent();
                    administrator.firstName = "Admin";
                    administrator.lastName = "Admin";
                    administrator.nickName = "Admin";
                    administrator.roles = [admin];
                    return [4 /*yield*/, administrator.save()];
                case 7:
                    _b.sent();
                    _b.label = 8;
                case 8:
                    for (_i = 0, entitiesPaths_1 = entitiesPaths; _i < entitiesPaths_1.length; _i++) {
                        path = entitiesPaths_1[_i];
                        if (path.endsWith("/*.entity.js")) {
                            path = path.substring(0, path.length - "/*.entity.js".length);
                        }
                        if (!fs.existsSync(path)) {
                            continue;
                        }
                        files = fs.readdirSync(path);
                        for (index in files) {
                            if (files[index].endsWith("ts"))
                                continue;
                            entity = require(path + "/" + files[index]);
                            if (entity.migrate) {
                                logger_1.logger.info("Running 'migrate' method for " + files[index]);
                                entity.migrate();
                            }
                        }
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.setup = setup;
function createAdmin() {
    return __awaiter(this, void 0, void 0, function () {
        var admin;
        return __generator(this, function (_a) {
            admin = new role_entity_1.default();
            admin.name = role_entity_1.default.ADMIN;
            admin.level = role_entity_1.default.ADMIN_LEVEL;
            admin.readableName = "Administrator";
            admin.description = "The Administator role";
            return [2 /*return*/, admin.save()];
        });
    });
}
function createStaff() {
    return __awaiter(this, void 0, void 0, function () {
        var staff;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    staff = new role_entity_1.default();
                    staff.name = role_entity_1.default.STAFF;
                    staff.level = role_entity_1.default.STAFF_LEVEL;
                    staff.readableName = "Staff";
                    staff.description = "Tge Staff role";
                    return [4 /*yield*/, staff.save()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
