"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
var base_entity_1 = require("./base.entity");
var role_entity_1 = require("./role.entity");
var media_entity_1 = require("./media.entity");
var decorators_1 = require("../graphql/decorators");
var SYNCHRONIZE = true;
function setSkipSync(skip) {
    SYNCHRONIZE = !skip;
}
exports.setSkipSync = setSkipSync;
var User = /** @class */ (function (_super) {
    __extends(User, _super);
    function User() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hiddenFields = ["password"];
        return _this;
    }
    User.prototype.hasRole = function (name) {
        for (var _i = 0, _a = this.roles; _i < _a.length; _i++) {
            var role = _a[_i];
            if (role.name == name) {
                return true;
            }
        }
        return false;
    };
    Object.defineProperty(User.prototype, "isAdmin", {
        get: function () {
            return this.hasRole(role_entity_1.default.ADMIN);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(User.prototype, "isStuff", {
        get: function () {
            return this.hasRole(role_entity_1.default.STAFF);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(User.prototype, "level", {
        get: function () {
            var max = 0;
            this.roles.forEach(function (r) {
                if (r.level > max) {
                    max = r.level;
                }
            });
            return max;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        typeorm_1.PrimaryGeneratedColumn(),
        decorators_1.GraphField({ type: "ID" }),
        __metadata("design:type", Number)
    ], User.prototype, "id", void 0);
    __decorate([
        typeorm_1.Column({ unique: true }),
        decorators_1.GraphField(),
        __metadata("design:type", String)
    ], User.prototype, "email", void 0);
    __decorate([
        typeorm_1.Column(),
        __metadata("design:type", String)
    ], User.prototype, "password", void 0);
    __decorate([
        typeorm_1.Column(),
        decorators_1.GraphField(),
        __metadata("design:type", String)
    ], User.prototype, "firstName", void 0);
    __decorate([
        typeorm_1.Column(),
        decorators_1.GraphField(),
        __metadata("design:type", String)
    ], User.prototype, "lastName", void 0);
    __decorate([
        typeorm_1.Column(),
        decorators_1.GraphField(),
        __metadata("design:type", String)
    ], User.prototype, "nickName", void 0);
    __decorate([
        typeorm_1.ManyToMany(function (_) { return role_entity_1.default; }, function (role) { return role.users; }, { eager: true }),
        typeorm_1.JoinTable(),
        decorators_1.GraphField({ type: "[Role]" }),
        __metadata("design:type", Array)
    ], User.prototype, "roles", void 0);
    __decorate([
        typeorm_1.OneToMany(function (_) { return media_entity_1.default; }, function (media) { return media.owner; }),
        __metadata("design:type", Array)
    ], User.prototype, "media", void 0);
    User = __decorate([
        typeorm_1.Entity("users", { synchronize: SYNCHRONIZE }),
        decorators_1.GraphQL()
    ], User);
    return User;
}(base_entity_1.default));
exports.default = User;
