/**
 * This module contains a set of standard verifiers to ensure user authentication
 * and authorization.
 */
import * as express from "express";
import Request from "./request";
/**
 * Verify that the user is authenticated.
 */
export declare function authUser(req: Request, _: express.Response): boolean;
/**
 * Verify that the user is NOT authenticated.
 */
export declare function notAuthUser(req: Request, res: express.Response): boolean;
/**
 * Verify that the user is logged and that is at least a Staff member.
 */
export declare function isStaffOrGreater(req: Request, res: express.Response): boolean;
